/*
 *  Copyright (C) 2008 dhewg, #wiidev efnet
 *
 *  this file is part of geckoloader
 *  http://wiibrew.org/index.php?title=Geckoloader
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include "system.h"
#include "usb.h"
#include "flash.h"
#include "debug.h"

void gecko_read_flash () {
        u32 len, i;
        u8 *p;

        len = flash_readcommand (FLASH_OFFSET + 0) << 24;
        len |= flash_readcommand (FLASH_OFFSET + 1) << 16;
        len |= flash_readcommand (FLASH_OFFSET + 2) << 8;
        len |= flash_readcommand (FLASH_OFFSET + 3);

        // TODO workaround, 1st byte is 0xff, which is incorrect. clueless here
        //len = len & 0xffffff;

        debug_string ("loader size on flash:");
        debug_uint (len);

        debug_string ("reading loader to:");
        debug_uint (LOADER_DOL_MEM_ADDR);

        p = (u8 *) LOADER_DOL_MEM_ADDR;
        for (i = 0; i < len; ++i)
                *p++ = flash_readcommand (FLASH_OFFSET + 4 + i);
}

void _main () {
        debug_string ("\n\rgeckoloader stub code " GECKOLOADER_VERSION);

        // Make sure 32Mhz is available on EXI Bus
        *(volatile unsigned long *) 0xcd00643c = 0x00000000;

        usb_flush ();

        gecko_read_flash ();

        debug_string ("loader was read from flash, relocating");

        dol_relocstart ((void *) LOADER_DOL_MEM_ADDR);
}

