/*
 *  Copyright (C) 2008 dhewg, #wiidev efnet
 *
 *  this file is part of geckoloader
 *  http://wiibrew.org/index.php?title=Geckoloader
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <malloc.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

#include <ogcsys.h>

static void *xfb = NULL;
static GXRModeObj *rmode;

void (*reload) () = (void (*) ()) 0x80001800;

int main() {
        VIDEO_Init ();

        switch (VIDEO_GetCurrentTvMode())
        {
                case VI_NTSC:
                        rmode = &TVNtsc480IntDf;
                        break;
                case VI_PAL:
                        rmode = &TVPal528IntDf;
                        break;
                case VI_MPAL:
                        rmode = &TVMpal480IntDf;
                        break;
                default:
                        rmode = &TVNtsc480IntDf;
                        break;
        }

        PAD_Init ();

        xfb = MEM_K0_TO_K1 (SYS_AllocateFramebuffer (rmode));

        VIDEO_Configure (rmode);
        VIDEO_SetNextFramebuffer (xfb);
        VIDEO_SetBlack (FALSE);
        VIDEO_Flush ();
        VIDEO_WaitVSync ();
        if (rmode->viTVMode&VI_NON_INTERLACE)
                VIDEO_WaitVSync ();

        console_init(xfb, 20, 64, rmode->fbWidth, rmode->xfbHeight,
                     rmode->fbWidth * 2);
        VIDEO_SetNextFramebuffer (xfb);

        printf ("geckoloader test application\n\n"
                "press START to jump back to the loader\n");

        while (1) {
                PAD_ScanPads ();
                if (PAD_ButtonsDown (0) & PAD_BUTTON_START) 
                        break;
                VIDEO_WaitVSync ();
        }

        printf ("executing the stub\n");
        VIDEO_WaitVSync ();

        reload ();

        printf ("eh?\n");
        VIDEO_WaitVSync ();

        return 0;
}

